#pragma once
#include "Renderable.h"

class CalCoreModel;
class CalModel;
class GLUtesselator;

/*
a renderable object using the cal3d avatar library

much of this code is taken from the Cal3d mini-viewer
*/

class Cal3DAvatar :
	public Renderable
{
public:
	Cal3DAvatar(void);
	~Cal3DAvatar(void);

	//rendering functions
	void init(void);
	void render(void);
	void update(float elapsedSeconds);
	void renderShadowVolumes(Vertex *lightPosition);
	void rotateY(float rads) {}

protected:
	//all Cal3d stuff, taken from the mini-viewer
	GLUtesselator *tess;
	bool parseModelConfiguration(char *strFilename);
  void renderModel();

CalCoreModel *m_calCoreModel;
CalModel *m_calModel;
  int m_currentAnimationId;
  float m_leftAnimationTime;
  float m_blendTime;
  int m_vertexCount;
  int m_faceCount;
  float m_scale;
};
