#pragma once

class Vertex;

//a light in the scene

class Light
{
public:
	//takes the light's position and its opengl id
	Light(int id, float pos[]);
	virtual ~Light(void);

	//rendering functions
	void init();
	void render(void);
	//turn the light on or off (depending on the parameter)
	void enable(bool e);
	//returns the light's position
	Vertex *getPosition(void) { return position; }

private:
	//true if the light is enabled in opengl
	bool enabled;
	//opengl id for the light
	int lightId;
	//the light's position stored for easy use with opengl
	float light_position[4];
	//the light's position stored for easy use in calculations in the rest of the system
	Vertex *position;
};
