#pragma once
#include "thing.h"

class Vertex;
class Universe;
class Polygon;

//a rectangular mirror. An object of this class only provides the reflecting surface
//some surrounding frame and back should be supplied for the mirror to look correct

class Mirror :
	public Thing
{
public:
	//create a rectangular mirror with the given opposite corners in the supplied universe
	Mirror(Vertex *point1, Vertex *point2, Universe *uni);
	virtual ~Mirror(void);

	//rendering methods
	void render(void);
	void init(void);
	virtual void renderShadowVolumes(Vertex *lightPosition) {rend->renderShadowVolumes(lightPosition);}

	//returns true so we know to render the mirror in the reflector rendering pass
	virtual bool reflects();

private:
	//helper method to render the object as a reflector
	void renderReflect();

	//one corner of the mirror's polygon, the other is stored in positionX etc
	//in Thing, both stored for convenience, since they are duplicated in polygon
	float x2, y2, z2;
	//reference to the scene in which the mirror resides, so we can display a reflection
	//of it
	Universe *universe;
};
