#include "StdAfx.h"
#include "renderable.h"
#include "polygon.h"
#ifdef VC71
#include <GL/glut.h>
#else
#include "glut.h"
#endif

#include <iostream>


using namespace std;

Renderable::Renderable(void)
{
}

Renderable::~Renderable(void)
{
}

void Renderable::renderProjectedShadows(Vertex *lightPosition, float yPlane)
{
	//projection matrix
	GLfloat shadowMat[4][4];
    // First row
    shadowMat[0][0] = (*lightPosition)(1) - yPlane;
    shadowMat[0][1] = 0.0f;
    shadowMat[0][2] = 0.0f;
    shadowMat[0][3] = 0.0f;

    // Second row
    shadowMat[1][0] = -(*lightPosition)(0);
	shadowMat[1][1] = -yPlane;
    shadowMat[1][2] = -(*lightPosition)(2);
    shadowMat[1][3] = -1.0f;

    // Third row
    shadowMat[2][0] = 0.0f;
    shadowMat[2][1] = 0.0f;
    shadowMat[2][2] = (*lightPosition)(1) - yPlane;
    shadowMat[2][3] = 0.0f;

    // Fourth row
    shadowMat[3][0] = (yPlane * (*lightPosition)(0));
    shadowMat[3][1] = (yPlane * (*lightPosition)(1));
    shadowMat[3][2] = (yPlane * (*lightPosition)(2));
    shadowMat[3][3] = (*lightPosition)(1);

	glMultMatrixf((GLfloat *)shadowMat);
	
	render();
}
