#pragma once

class Vertex;

/*
interface for a renderable object in the scene
*/

class Renderable
{
public:
	Renderable(void);
	virtual ~Renderable(void);

	virtual void render(void) = 0;
	virtual void renderShadowVolumes(Vertex *lightPosition) {}
	virtual void renderProjectedShadows(Vertex *lightPosition, float yPlane);
	virtual void rotateY(float rads) = 0;

	virtual void update(float elapsedSeconds) {}
	virtual void init(void) {}
};
