#pragma once

#include "renderable.h"

class Vertex;

/*
a thing is anything that appears in the scene
this class stores all the general properties of an object in the scene

an abstract class
*/

class Thing
{
public:
	Thing(void);
	virtual ~Thing(void);

	//rendering funcs
	virtual void render(void);
	virtual void update(float elapsedSeconds) {}
	virtual void renderShadowVolumes(Vertex *lightPosition);
	virtual void renderProjectedShadows(Vertex *lightPosition);
	virtual void init(void) = 0;

	//rotate the thing about the y axis (in radians)
	//does nothing by default
	void rotateY(float rads) { rend->rotateY(rads); }

	//set and get the co-ords of the thing
	virtual void setX(float x) {positionX = x;}
	virtual void setY(float y) {positionY = y;}
	virtual void setZ(float z) {positionZ = z;}
	virtual float getX() {return positionX;}
	virtual float getY() {return positionY;}
	virtual float getZ() {return positionZ;}

	//true if the thing is reflective (like a mirror, ie is used for reflections)
	virtual bool reflects() {return false;}


protected:
	//position and velocity of the thing
	float positionX;
	float positionY;
	float positionZ;
	float velocityX;
	float velocityY;
	float velocityZ;

	//renderable representation of the thing
	Renderable *rend;
};
