#include "stdafx.h"
#include "Application.h"
#include "Universe.h"

#include <vrj/Kernel/Kernel.h>


using namespace vrj;

int main(int argc, char **argv)
{
   // Allocate the kernel object and the application object
   Kernel* kernel = Kernel::instance();           // Get the kernel

   Universe *u = new Universe();
   Application* application = new Application(u);          

   // IF not args passed to the program
   //    Display usage information and exit
   if (argc <= 1)
   {
      std::cout << "\n\n";
      std::cout << "Usage: " << argv[0]
                << " vjconfigfile[0] vjconfigfile[1] ... vjconfigfile[n]"
                << std::endl;
      exit(1);
   }

   // Load any config files specified on the command line
   for( int i = 1; i < argc; ++i )
   {
      kernel->loadConfigFile(argv[i]);
   }

   // Start the kernel running
   kernel->start();

   // Give the kernel an application to execute
   kernel->setApplication(application);

   // Keep thread alive and waiting
   kernel->waitForKernelStop();

   // Destroy the application
   delete application;

	return 0;             
}
